<?php declare(strict_types=1);

namespace App\Providers;

use App\Captcha\Contracts\ImageBody;
use App\Captcha\Contracts\ImageHead;
use App\Captcha\Contracts\ImageLines;
use App\Captcha\Contracts\ImageManager as ImageManagerContract;
use App\Captcha\Images\Body;
use App\Captcha\Images\Head;
use App\Captcha\Images\ImageManager;
use App\Captcha\Images\Lines;
use App\Services\Api\V1\CaptchaService;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Support\ServiceProvider;
use Illuminate\Validation\Rules\Password;

final class AppServiceProvider extends ServiceProvider
{
    /**
     * Register any application services.
     */
    public function register(): void
    {
        $this->app->bind(ImageManagerContract::class, function () {
            return new ImageManager(imageClassName: config('captcha.imageClass'));
        });
        $this->app->bind(ImageHead::class, Head::class);
        $this->app->bind(ImageBody::class, Body::class);
        $this->app->bind(ImageLines::class, Lines::class);

        $this->app->bind(CaptchaService::class, function (Application $app) {
            return new CaptchaService(
                config: config('captcha', []),
                imageHead: $app->make(ImageHead::class),
                imageBody: $app->make(ImageBody::class)
            );
        });
    }

    /**
     * Bootstrap any application services.
     */
    public function boot(): void
    {
        Password::defaults(function () {
            $rule = Password::min(8);

            return $this->app->isProduction()
                ? $rule->letters()
                       ->mixedCase()
                       ->numbers()
                       ->symbols()
                       ->uncompromised()
                : $rule;
        });
    }
}
